org.vishia.gral.awt

## Class AwtTextBox

- java.lang.Object
- - org.vishia.gral.base.GralWidget.ImplAccess
  - - org.vishia.gral.base.GralTextField.GraphicImplAccess
    - - org.vishia.gral.base.GralTextBox.GraphicImplAccess
      - - org.vishia.gral.awt.AwtTextBox

- All Implemented Interfaces:
    GralWidgImpl_ifc

      public class AwtTextBox
      extends GralTextBox.GraphicImplAccess

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `AwtTextBox.AwtTextAreaImpl`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected GralGraphicTimeOrder` | `changeText`
    `protected GralGraphicTimeOrder` | `changeTextBoxTrail`
    `(package private) java.lang.StringBuffer` | `newText`
    `(package private) java.awt.Label` | `promptSwt` A possible prompt for the text field or null.
    `protected AwtTextBox.AwtTextAreaImpl` | `textFieldSwt`

    - ### Fields inherited from class org.vishia.gral.base.GralTextBox.GraphicImplAccess

      `chgAddText, chgCursor, chgEditable, chgNonEditable, chgViewTrail`

    - ### Fields inherited from class org.vishia.gral.base.GralTextField.GraphicImplAccess

      `chgPrompt, posField, posPrompt`

    - ### Fields inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `chgBitsDerived, chgColorBack, chgColorLine, chgColorText, chgFloat, chgFocus, chgFont, chgIntg, chgInvisible, chgObjects, chgPos, chgText, chgVisible, chgVisibleInfo, pixBounds, wdgimpl, widgg`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AwtTextBox(GralTextBox widgg, java.awt.Container parent, int style, AwtWidgetMng mng)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `GralRectangle` | `getPixelPositionSize()`
    `java.lang.Object` | `getWidgetImplementation()` Returns the implementation class of the widget.
    `void` | `removeWidgetImplementation()` Removes the graphical widget in the graphic.
    `void` | `repaintGthread()` This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
    `void` | `setBoundsPixel(int x, int y, int dx, int dy)`
    `boolean` | `setFocusGThread()` Sets the focus to the widget.
    `void` | `setVisibleGThread(boolean bVisible)` Sets the implementation widget(s) visible state.

    - ### Methods inherited from class org.vishia.gral.base.GralTextBox.GraphicImplAccess

      `caretPos, caretPos, getAndClearNewText, user`

    - ### Methods inherited from class org.vishia.gral.base.GralTextField.GraphicImplAccess

      `borderwidth, isPasswordField, prompt, promptStylePosition, setTouched`

    - ### Methods inherited from class org.vishia.gral.base.GralWidget.ImplAccess

      `acknChanged, actionShow, dyda, getActionChange, getChanged, gralWidgetFromImplData, setDragEnable, setDropEnable, setFocused, setTextChanged, setVisibleState, XXXfocusGained`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### textFieldSwt

          protected AwtTextBox.AwtTextAreaImpl textFieldSwt

    - #### promptSwt

          java.awt.Label promptSwt

      A possible prompt for the text field or null.

    - #### newText

          java.lang.StringBuffer newText

    - #### changeTextBoxTrail

          protected GralGraphicTimeOrder changeTextBoxTrail

    - #### changeText

          protected GralGraphicTimeOrder changeText

  - ### Constructor Detail

    - #### AwtTextBox

          public AwtTextBox(GralTextBox widgg,
                            java.awt.Container parent,
                            int style,
                            AwtWidgetMng mng)

  - ### Method Detail

    - #### getWidgetImplementation

          public java.lang.Object getWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Returns the implementation class of the widget. If the widget has more as one implementation widgets, this method returns one of the widgets, usual the first important one respectively that widget which represents the implementation layer. A widget of the implementation layer is a SWT.control or a `Component`.
      If more as one widget are part of the GralWidget, use the special `GralWidget._wdgImpl` class which should contain the references to that implementation widgets.

    - #### setBoundsPixel

          public void setBoundsPixel(int x,
                                     int y,
                                     int dx,
                                     int dy)

    - #### repaintGthread

          public void repaintGthread()

      Description copied from interface: `GralWidgImpl_ifc`
      This method should be implemented in all Widget implementations of the adapter for the underlying graphic system.
      Implementation hints: In SWT it should call redraw().
      It is possible that the widget consists of more as one graphical widget, then all of it should be redrawn. It is possible that some data are set in another thread, they should be applied to the widgets firstly. It is possible that the widget is removed though a repaintGthread-order is pending from the time before deleting, for example if the graphic layout is changed.
      See `#repaintRequ`

    - #### setFocusGThread

          public boolean setFocusGThread()

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the focus to the widget. See `GralMng_ifc#setFocus(GralWidget)`.
      Returns:
        true if it has the focus after this operation. false on any error.

    - #### removeWidgetImplementation

          public void removeWidgetImplementation()

      Description copied from interface: `GralWidgImpl_ifc`
      Removes the graphical widget in the graphic.

    - #### setVisibleGThread

          public void setVisibleGThread(boolean bVisible)

      Description copied from interface: `GralWidgImpl_ifc`
      Sets the implementation widget(s) visible state. The widgets are really invisible, or they are visible in principle, but they can be covered by other windows or clipping. This method should set the `GralWidget.bVisibleState` too. Therewith it is able to quest `GralWidget.isVisible()` in any thread.
      Parameters:
        `bVisible` - true then the widget should be visible, false it is set to invisible.

    - #### getPixelPositionSize

          public GralRectangle getPixelPositionSize()